<template>
  <modal-dialog
    title="Credentials Details"
    static
    :confirm="
      editable && valid
        ? dirty
          ? !exists
            ? 'Create'
            : 'Update'
          : 'Update'
        : null
    "
    @close="modalClose"
  >
    <h5>
      <code>{{ credentialId }}</code> (<i :class="iconClass"></i>
      {{ inferedType }})
    </h5>
    <form :action="`${apiUrl}/vault/${currentId}`" method="post">
      <div class="form-group">
        <label for="vault-id">ID</label>
        <input
          class="form-control"
          type="text"
          id="vault-id"
          v-model="currentId"
          @input="idChanged"
        />
      </div>
      <div class="form-group" v-if="editable || readonly">
        <label for="vault-value">Value</label>
        <textarea
          :readonly="readonly"
          name="vault-value"
          id="vault-value"
          v-model="data.value"
          class="form-control"
          rows="4"
        ></textarea>
      </div>
    </form>
    <template v-if="!exists && editable">
      <div class="alert alert-warning mt-3" v-if="isInferedSandbox">
        This will create <strong>sandbox credentials</strong>. In most cases,
        this does not make sense and should not be done
        <strong>unless you really know what you are doing</strong>.
      </div>
      <div class="alert alert-success mt-3" v-else-if="valid">
        This will create new credentials with id <code>{{ currentId }}</code
        >. You can reference this secret in your configurations as
        <code>#!#:{{ currentId }}</code
        >.
      </div></template
    >
    <div
      class="alert alert-success mt-3"
      v-if="exists && !dirty && inferedType === 'credentials'"
    >
      This will overwrite credentials with id <code>{{ currentId }}</code
      >. You can reference this secret in your configurations as
      <code>#!#:{{ currentId }}</code
      >.
    </div>
    <div v-if="exists && !editable" class="alert alert-warning mt-3">
      Credentials with id <code>{{ currentId }}</code> already exist and cannot
      be edited.
    </div>
    <div v-if="exists && editable && dirty" class="alert alert-warning mt-3">
      Credentials with id <code>{{ currentId }}</code> already exist. Make sure
      you know what you are doing.
    </div>
    <div v-else-if="!editable && !exists" class="alert alert-danger mt-3">
      <code>{{ currentId }}</code> is a reserved name and cannot be created
    </div>
    <api-data
      :endpoint="`/vault/${credentialId}`"
      v-model="data"
      @success="idChanged"
      @failure="$emit('close')"
    />
  </modal-dialog>
</template>

<script>
const { getVaultItemConfig } = require("@/helpers/constants.js");

export default {
  name: "CredentialsDetails",
  emits: ["close"],
  data() {
    return {
      data: {},
      inferedType: null,
      timeoutId: null,
    };
  },
  props: {
    credentialId: {
      type: String,
      default: null,
    },
    existing: {
      type: Array,
      default: () => [],
    },
  },
  inject: ["saveCredentials"],
  methods: {
    modalClose(event) {
      if (event.value) {
        var value;
        if (!this.data.value) value = null;
        else value = this.data.value;
        this.saveCredentials({ id: this.currentId, value });
      }
      this.$emit("close");
    },
    idChanged() {
      if (this.timeoutId !== null) clearTimeout(this.timeoutId);
      this.timeoutId = setTimeout(() => {
        this.inferType(this.currentId);
      }, 100);
    },
    inferType(inferId) {
      this.timeoutId = null;
      if ((inferId || "").length === 0) return null;
      import("axios").then(({ default: axios }) => {
        axios
          .get(`${this.apiUrl}/vault/${inferId}/type`, {
            withCredentials: true,
          })
          .then((response) => {
            this.inferedType = response.data.type;
          })
          .catch((error) => this.notify(error, error.name, "error"));
      });
    },
  },
  computed: {
    valid() {
      // TODO: Not every non-null is valid
      return this.currentId.length > 0;
    },
    exists() {
      return this.existing.includes(this.data.id);
    },
    dirty() {
      return this.currentId !== this.credentialId;
    },
    readonly() {
      return this.isInferedSandbox && this.exists;
    },
    editable() {
      return !(
        this.inferedType === "storage" ||
        (this.isInferedSandbox && this.exists)
      );
    },
    value: {
      get() {
        if (this.data.show) return this.data.value;
        return "";
      },
      set(content) {
        this.data.value = content;
      },
    },
    iconClass() {
      return getVaultItemConfig(this.inferedType).icon;
    },
    isPublic() {
      return getVaultItemConfig(this.inferedType).show;
    },
    isInferedSandbox() {
      return (
        this.inferedType === "sandbox" ||
        this.inferedType === "datamart" ||
        this.inferedType === "share"
      );
    },
    currentId: {
      get() {
        return this.data.id || "";
      },
      set(value) {
        this.data.id = value;
        this.idChanged();
      },
    },
  },
};
</script>

<style></style>
